// RTC clock using LCD display with 16 columns, 4 lines
// Set time format YYMMddhhmmss;

#include <Wire.h>              // include I2C communication
#include <stdio.h>
#include <PCF8583.h>           // include for RTC unit PCF8583
#include <LiquidCrystal.h>
LiquidCrystal lcd(12, 11, 5, 4, 3, 2);  // initialize the LCD interface pins

int  correct_address=0, yearof=2000; byte of=48, mu=10; 
PCF8583 p (0xA0);	

void setup(void)
{ Serial.begin(9600);
  Serial.println("starting");
  lcd.begin(16, 4);               // set up the LCD' 16 columns , 4 lines: 
  lcd.setCursor(3, 0); lcd.print("RTC Clock");
}

void loop(void)
{ if(Serial.available() > 0)
  {  p.year=(byte) ((Serial.read()-of)*mu+(Serial.read()-of))+yearof;
     p.month=(byte) ((Serial.read()-of)*mu+(Serial.read()-of));
     p.day=(byte) ((Serial.read()-of)*mu+(Serial.read()-of));
     p.hour=(byte) ((Serial.read()-of)*mu+(Serial.read()-of));
     p.minute=(byte) ((Serial.read()-of)*mu+(Serial.read()-of));
     p.second=(byte) ((Serial.read()-of)*mu+(Serial.read()-of));   
     if(Serial.read()==';') { Serial.println("setting date"); p.set_time();}
  }
  p.get_time();
  char time[50]; char date[50];
  sprintf(time, "%02d:%02d:%02d", p.hour, p.minute, p.second);
  sprintf(date, "%02d/%02d/%02d", p.year, p.month, p.day);
  Serial.print(date); Serial.print(" - "); Serial.println(time);
  lcd.setCursor(3, 1); lcd.print(time);
  lcd.setCursor(19, 0); lcd.print(p.day); lcd.print(". ");
  switch (p.month)
	{ case 1 : lcd.print ("Januar    "); break;
	  case 2 : lcd.print ("Februar   "); break;
	  case 3 : lcd.print ("Maerz     "); break;
	  case 4 : lcd.print ("April     "); break;
	  case 5 : lcd.print ("Mai       "); break;
	  case 6 : lcd.print ("Juni      "); break;
	  case 7 : lcd.print ("Juli      "); break; 
        case 8 : lcd.print ("August    "); break;
	  case 9 : lcd.print ("September  "); break;
	  case 10 : lcd.print ("Oktober   "); break; 
	  case 11 : lcd.print ("November  "); break;
	  case 12 : lcd.print ("Dezember  "); break; 
        }
  lcd.setCursor(21, 1); lcd.print(p.year); delay(100);
}

